#include "/lib/all_the_uniforms.glsl"
varying vec2 texcoord;
#include "/lib/util.glsl"
#include "/lib/tonemap.glsl"
#include "/lib/blur.glsl"
#include "/lib/settings.glsl"

// Color grading, Bloom final

/* DRAWBUFFERS:0 */

void main() {
	gl_FragData[0] = texture2D(colortex0, texcoord);
	#ifdef BLOOM 
		float Offset = 0;
		vec4 FinalBloom = vec4(0, 0, 0, 1);
		for(int i = 2; i <= 2+BLOOM_SIZE; i++) {
			FinalBloom += texture2D(colortex1, texcoord/pow(2, i)+Offset);
			Offset += 1/pow(2, i);
		}
		gl_FragData[0] += FinalBloom * BLOOM_STRENGTH;
	#endif
	gl_FragData[0].xyz = ACESFilm(gl_FragData[0].xyz);

	vec3 MinBright = vec3(TONEMAP_MIN_R, TONEMAP_MIN_G, TONEMAP_MIN_B);
	#ifdef FILM_GRAIN
	MinBright += random(gl_FragCoord.xy/64+random(vec2(frameTimeCounter)))*0.05;
	#endif
	gl_FragData[0].xyz = max(gl_FragData[0].xyz, MinBright);

	gl_FragData[0].xyz = apply_contrast(gl_FragData[0].xyz, CONTRAST);
	gl_FragData[0].xyz = apply_vibrance(gl_FragData[0].xyz, VIBRANCE);
	gl_FragData[0].xyz = apply_saturation(gl_FragData[0].xyz, SATURATION);

	#ifdef DEBUG_BUFFER
	gl_FragData[0] = texture2D(colortex1, texcoord);
	#endif
}
