#include "/lib/all_the_uniforms.glsl"
uniform sampler2D lightmap;
uniform sampler2D gtexture;

varying vec2 texcoord;
varying vec4 glcolor;
varying vec3 ViewPos;
varying vec3 SunVec;

#include "/lib/util.glsl"
#include "/lib/tonemap.glsl"

#include "/lib/settings.glsl"
#include "/global/sky.glsl"

void main() {
	/* DRAWBUFFERS:02 */
	vec4 data = texture2D(gtexture, texcoord) * glcolor;
	vec4 SkyColor = vec4(calcSkyColor(normalize(ViewPos), SunVec), 0.01);
	#ifdef BORDER_FOG
    gl_FragData[1].xyz = SkyColor.xyz;
	#endif
	if(data.r == data.g && data.g == data.b && data.r > 0.0) { 
		vec3 StarCoord = normalize(to_player_pos(ViewPos));
		// Make the stars vary in brightness
		SkyColor += fbm_fast(StarCoord.xz*64, 1) * clamp(sqrt(StarCoord.y)+0.2, 0, 1) * data.a * 4;
	}
	gl_FragData[0] = SkyColor;
	
	
}
